DROP DATABASE IF EXISTS fakturix;

CREATE DATABASE fakturix;

use fakturix ;

DROP TABLE IF EXISTS kontrahent ;

CREATE TABLE kontrahent
	(
	id 		INT(8) 		NOT NULL AUTO_INCREMENT PRIMARY KEY,
	nip 		VARCHAR(10) 	NOT NULL, 
	nazwa 		VARCHAR(255) 	NOT NULL,
	regon		VARCHAR(11)	NOT NULL,
	ulica		VARCHAR(100)	NOT NULL,
	kod		INT(6)		NOT NULL,
	miejscowosc	VARCHAR(100)	NOT NULL,
	podpis		VARCHAR(100)	NOT NULL
	);
	

DROP TABLE IF EXISTS towar ;

CREATE TABLE towar
	(
	id		INT(8)		NOT NULL AUTO_INCREMENT PRIMARY KEY,
	kod		INT(6)		NOT NULL,
	typ	ENUM('towar','usluga')	NOT NULL,
	nazwa		VARCHAR(100)	NOT NULL,
	pkwiu		VARCHAR(15)	NOT NULL,
	cena		INT(10)		NOT NULL,
	stawkaVAT	INT(8)		NOT NULL
	);


DROP TABLE IF EXISTS faktura ;

CREATE TABLE faktura
	(
	id		INT(8)		NOT NULL AUTO_INCREMENT PRIMARY KEY,
	numer		INT(15)		NOT NULL,
	miejscowosc	VARCHAR(100)	NOT NULL,
	data		DATETIME	NOT NULL,
	kontrahentNip	VARCHAR(11)	NOT NULL,
	kontrahentNazwa	VARCHAR(255)	NOT NULL,
	kontrahentUlica	VARCHAR(100)	NOT NULL,
	kontrahentMiejscowosc	
			VARCHAR(100)	NOT NULL,
	kontrahentKod	INT(6)		NOT NULL,
	kontrahentPodpis	
			VARCHAR(100)	NOT NULL,
	razem		INT(20)		NOT NULL,
	dataSprzedazy	DATETIME	NOT NULL
	);

DROP TABLE IF EXISTS szczegolyFaktura ;

CREATE TABLE szczegolyFaktura
	(
	id		INT(8)		NOT NULL AUTO_INCREMENT PRIMARY KEY,
	fakturaId	INT(8)		NOT NULL,
	towarId		INT(8)		NOT NULL,
	towarNazwa	VARCHAR(100)	NOT NULL,
	towarCena	INT(10)		NOT NULL,
	towarStawka	VARCHAR(5)	NOT NULL,
	towarIlosc	INT(10)		NOT NULL
	);
			
DROP TABLE IF EXISTS stawkaVat ;

CREATE TABLE stawkaVat
	(
	id		INT(8)		NOT NULL AUTO_INCREMENT PRIMARY KEY,
	stawka		VARCHAR(10)	NOT NULL
	);

