/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/** \file
 * \brief Zawiera funkcje zwrotne
 *
 * Funkcje operuja na obiektach formularzy i wykonuja
 * przewidywane dla nich dzialania.
 * \author Michal Lachowicz <MLachowicz@elka.pw.edu.pl>
 */

#include "callbacks.h"

/**
 *	\todo Moze jakos bardziej obyektowo
 *	mozna pobrac tak podstawowy parametr przekazac ???
 *	a wogole to deprecated i nalezy uzywac CTree
 */
gint selRowSzukajKontrahent = -1;	///< Zaznaczony wiersz listy -1 w przypadku kiedy zaden wiersz nie zaznaczony
gint selRowFaktura = -1;	///< Zaznaczony wiersz listy
gint selRowSzukajTowar = -1;	///< Zaznaczony wiersz listy

void
on_new1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_save1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_quit1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

  //gtk_main_quit();
  on_fakturaWindow_delete_event (NULL, NULL, NULL);

}


void
on_cut1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_copy1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_paste1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_clear1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_properties1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_preferences1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void
on_about1_activate (GtkMenuItem * menuitem, gpointer user_data)
{

  GtkWidget *aboutWindow;

  aboutWindow = create_aboutWindow ();
  gtk_widget_show (aboutWindow);

}


void
on_fakturaToolBoxButtonNowy_clicked (GtkButton * button, gpointer user_data)
{

}


void
on_fakturaToolBoxButtonZapisz_clicked (GtkButton * button, gpointer user_data)
{

}


void
  on_fakturaToolBoxButtonWydrukuj_clicked
  (GtkButton * button, gpointer user_data)
{

  struct fFaktura *faktura;
  struct fKontrahent *kontrahent;
  struct fAdres *adres;
  struct fSzczegol *szczegol;
  struct fRazem *razem;
  struct fStawka *stawka;

  gchar *temp2;
  xmlChar *temp;

  //alokacja pamieci
  faktura = malloc (sizeof (struct fFaktura));
  kontrahent = malloc (sizeof (struct fKontrahent));
  adres = malloc (sizeof (struct fAdres));
  szczegol = malloc (sizeof (struct fSzczegol));
  razem = malloc (sizeof (struct fRazem));
  stawka = malloc (sizeof (struct fStawka));

  //Wypelnianie struktury faktury
  faktura->id1 = 123;
  faktura->id2 = 321;

  temp = "01/06/03";

  gtk_entry_set_text (GTK_ENTRY (lookup_widget (fakturaWindow,
						"fakturaEntryNumerFaktury")),
		      temp);

  faktura->numer =
    gtk_entry_get_text (GTK_ENTRY
			(lookup_widget
			 (fakturaWindow, "fakturaEntryNumerFaktury")));


  temp = gtk_entry_get_text (GTK_ENTRY (lookup_widget (fakturaWindow,
						       "fakturaEntryMiejscowosc")));

  faktura->miejscowosc_wystawienia = temp;


  //g_printf("miejscowosc=%s\n",temp);
  //temp="01/07/03";
  //g_printf("numer=%s\ttemp=%s\n",faktura->numer,temp);

  temp = "01/06/2003";

  Egtk_entry_set_text (fakturaWindow, "fakturaEntryData", temp);

  faktura->numer = Egtk_entry_get_text (fakturaWindow, "fakturaEntryData");

  faktura->data_wystawienia =
    Egtk_entry_get_text (fakturaWindow, "fakturaEntryData");

  faktura->sposob_zaplaty = Egtk_entry_get_text (fakturaWindow,
						 "fakturaComboEntrySposobZaplaty");

  faktura->data_sprzedazy = Egtk_entry_get_text (fakturaWindow,
						 "fakturaEntryDataSprzedazy");

  faktura->otrzymujacy = Egtk_entry_get_text (fakturaWindow,
					      "fakturaEntryPodpis");
  g_printf ("%s\n", faktura->otrzymujacy);

  temp = "Micha Lachowicz";

  // ChGW po co to jest xmlCheckUTF8 (temp);

  faktura->wystawiajacy = temp;

  // Wypelnianie struktury kontrahenta  

  kontrahent->id1 = 123;
  kontrahent->id2 = 321;

  kontrahent->nazwa = Egtk_entry_get_text (fakturaWindow,
					   "fakturaEntryKontrahentNazwa");

  kontrahent->nip = fakturaWindowKontrahentNip ();

  kontrahent->regon = "1234567890";

  kontrahent->telefon = "94-3121234";

  kontrahent->email = "MLachowicz@elka.pw.edu.pl";

  kontrahent->konto = "1789783921789321879321897";

  //Wypelnianie struktury adresu kontrahenta

  adres->ulica = Egtk_entry_get_text (fakturaWindow,
				      "fakturaEntryKontrahentUlica");

  adres->miejscowosc = Egtk_entry_get_text (fakturaWindow,
					    "fakturaEntryKontrahentMiejscowosc");

  //z finterface.c
  adres->kod = fakturaWindowKontrahentKod ();

  //Konczymy kontrahenta
  kontrahent->adres = adres;

  //Wypelnianie struktury szczegoly
  szczegol->lp = 1;
  szczegol->nazwa = "Noze kuchenne";
  szczegol->pkwiu = "12345";
  szczegol->ilosc = 1;
  szczegol->jd_miary = "szt.";
  szczegol->cena_jd = 100;
  szczegol->wartosc_netto = szczegol->ilosc * szczegol->cena_jd;
  szczegol->stawka_vat = "22%";
  szczegol->kwota_podatku = 22;
  szczegol->wartosc_brutto = 122;

  //Wypelnianie strutury razem
  razem->wartosc_netto = 100;
  razem->kwota_podatku_vat = 22;
  razem->wartosc_brutto = razem->wartosc_netto + razem->kwota_podatku_vat;

  //Wypelninie struktury stawki
  stawka->stawka = "22%";
  stawka->wartosc_netto = 100;
  stawka->kwota_podatku_vat = 22;
  stawka->wartosc_brutto = stawka->wartosc_netto + stawka->kwota_podatku_vat;

  //Konczymy razem
  razem->stawka_ilosc = 1;
  razem->stawka = g_ptr_array_new ();
  g_ptr_array_add (razem->stawka, stawka);

  //Konczymy fakture
  faktura->nabywca = kontrahent;
  faktura->szczegoly_ilosc = 1;
  faktura->szczegoly = g_ptr_array_new ();
  faktura->razem = razem;
  g_ptr_array_add (faktura->szczegoly, szczegol);

  // z print.c
  g_print ("przed print\n");
  printFaktura ("faktura01.xml", faktura);

  //Zwolnienie pamieci
  free (faktura);
  free (kontrahent);
  free (adres);
  free (razem);
  g_ptr_array_free (faktura->szczegoly, TRUE);
  g_ptr_array_free (faktura->razem->stawka, TRUE);

}


void
on_fakturaToolBoxButtonZakoncz_clicked (GtkButton * button,
					gpointer user_data)
{
  //zamkniecie aplikacji
  on_fakturaWindow_delete_event (NULL, NULL, NULL);

  //gtk_main_quit();

}


void
on_fakturaEntryKontrahentNip1_changed (GtkEditable * editable,
				       gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 3)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "fakturaEntryKontrahentNip2"));
  //przeskakuje do nastepnego z NIPow
}


void
on_fakturaEntryKontrahentNip2_changed (GtkEditable * editable,
				       gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 3)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "fakturaEntryKontrahentNip3"));

}


void
on_fakturaEntryKontrahentNip3_changed (GtkEditable * editable,
				       gpointer user_data)
{
  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 2)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "fakturaEntryKontrahentNip4"));

}


void
on_fakturaEntryKontrahentNip4_changed (GtkEditable * editable,
				       gpointer user_data)
{
  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 2)
    sqlFillKontrahent (GTK_WIDGET (editable));

}


void
on_fakturaButtonKontrahentNowy_clicked (GtkButton * button,
					gpointer user_data)
{

  //GtkWidget *kontrahentWindow;
  GtkWidget *fakturaWindow;

  fakturaWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("create\n");
  kontrahentWindow = create_kontrahentWindow ();
  //g_print("create\n");
  gtk_widget_show (kontrahentWindow);
  //g_print("show\n");
  gtk_window_set_modal (GTK_WINDOW (kontrahentWindow), TRUE);
  //g_print("set_modal\n");
  gtk_window_set_transient_for (GTK_WINDOW (kontrahentWindow),
				GTK_WINDOW (fakturaWindow));
  //g_print("set_transient_for\n");
}


void
  on_fakturaButtonKontrahentZnajdz_clicked
  (GtkButton * button, gpointer user_data)
{

  GtkWidget *szukajKontrahentWindow;
  GtkWidget *fakturaWindow;

  fakturaWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("create\n");
  szukajKontrahentWindow = create_szukajKontrahentWindow ();
  //g_print("create\n");
  gtk_widget_show (szukajKontrahentWindow);
  //g_print("show\n");
  gtk_window_set_modal (GTK_WINDOW (szukajKontrahentWindow), TRUE);
  //g_print("set_modal\n");
  gtk_window_set_transient_for (GTK_WINDOW (szukajKontrahentWindow),
				GTK_WINDOW (fakturaWindow));
  //g_print("set_transient_for\n");

}


void
on_fakturaButtonSzczegolyDodaj_clicked (GtkButton * button,
					gpointer user_data)
{
  GtkCList *list;
  GtkWidget *fakturaWindow;
  GtkEntry *entry;
  G_CONST_RETURN gchar *row[6];
  gchar *text[6];
  gint i;
  gdouble razem;
  gchar buffer[26];

  fakturaWindow = GTK_WIDGET (gtk_widget_get_toplevel (GTK_WIDGET (button)));

  //entry = GTK_ENTRY(lookup_widget(fakturaWindow,"fakturaEntryNazwa"));
  //row[0] = gtk_entry_get_text(GTK_ENTRY(entry));
  row[0] = Egtk_entry_get_text (fakturaWindow, "fakturaEntryNazwa");

  //entry = GTK_ENTRY(lookup_widget(fakturaWindow,"fakturaEntryPkwiu"));
  //row[1] = gtk_entry_get_text(entry); 
  row[1] = Egtk_entry_get_text (fakturaWindow, "fakturaEntryPkwiu");

  //entry = GTK_ENTRY(lookup_widget(fakturaWindow,"fakturaEntryCena"));
  //row[2] = gtk_entry_get_text(entry);
  row[2] = Egtk_entry_get_text (fakturaWindow, "fakturaEntryCena");

  //entry = GTK_ENTRY(lookup_widget(fakturaWindow,"fakturaEntryStawka"));
  //row[3] = gtk_entry_get_text(entry);
  row[3] = Egtk_entry_get_text (fakturaWindow, "fakturaEntryStawka");

  //entry = GTK_ENTRY(lookup_widget(fakturaWindow,"fakturaEntryIlosc"));
  //row[4] = gtk_entry_get_text(entry);
  row[4] = Egtk_entry_get_text (fakturaWindow, "fakturaEntryIlosc");

  razem = atof (row[2]) * atof (row[4]);

  //buffer = g_ascii_dtostr(buffer,25,razem);

  //g_printf("razem = %s\n",buffer);

  //row[5]="100";

	/** Kopiowanie g_char'ow
	*/
  for (i = 0; i < 6; i++)
    text[i] = g_strdup (row[i]);

  text[5] = g_ascii_dtostr (buffer, 25, razem);

  //g_print("text = %s\n",mysql_row);

  //list = GTK_CLIST(lookup_widget(fakturaWindow,"fakturaClist"));
  Egtk_clist_insert (fakturaWindow, "fakturaClist", 1, text);

  for (i = i; i < 6; i++)
    g_free (text[i]);
}


void
on_fakturaButtonSzczegolyUsun_clicked (GtkButton * button, gpointer user_data)
{

  if (selRowFaktura > -1)
    {
      //g_print("selRowFaktura=%d\n",selRowFaktura);
      //gtk_clist_remove(GTK_CLIST(
      //   lookup_widget(
      //      gtk_widget_get_toplevel(GTK_WIDGET(button)),
      //      "fakturaClist")),selRowFaktura);
      Egtk_clist_remove (fakturaWindow, "fakturaClist", selRowFaktura);
      selRowFaktura = -1;
    }

}


void
on_fakturaButtonSzczegolyOk_clicked (GtkButton * button, gpointer user_data)
{

}


void
  on_fakturaButtonSzczegolyZnajdz_clicked
  (GtkButton * button, gpointer user_data)
{

  GtkWidget *fakturaWindow;

  fakturaWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("create\n");
  szukajTowarWindow = create_szukajTowarWindow ();
  //g_print("create\n");
  gtk_widget_show (szukajTowarWindow);
  //g_print("show\n");
  gtk_window_set_modal (GTK_WINDOW (szukajTowarWindow), TRUE);
  //g_print("set_modal\n");
  gtk_window_set_transient_for (GTK_WINDOW (szukajTowarWindow),
				GTK_WINDOW (fakturaWindow));
  //g_print("set_transient_for\n");

}


void
on_fakturaButtonSzczegolyNowy_clicked (GtkButton * button, gpointer user_data)
{

  GtkWidget *fakturaWindow;

  fakturaWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("create\n");
  towarWindow = create_towarWindow ();
  //g_print("create\n");
  gtk_widget_show (towarWindow);
  //g_print("show\n");
  gtk_window_set_modal (GTK_WINDOW (towarWindow), TRUE);
  //g_print("set_modal\n");
  gtk_window_set_transient_for (GTK_WINDOW (towarWindow),
				GTK_WINDOW (fakturaWindow));
  //g_print("set_transient_for\n");

}


void
on_kontrahentEntryNip1_changed (GtkEditable * editable, gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 3)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "kontrahentEntryNip2"));

}


void
on_kontrahentEntryNip2_changed (GtkEditable * editable, gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 3)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "kontrahentEntryNip3"));

}


void
on_kontrahentEntryNip3_changed (GtkEditable * editable, gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 2)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "kontrahentEntryNip4"));

}


void
on_kontrahentEntryNip4_changed (GtkEditable * editable, gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 2)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "kontrahentEntryNazwa"));

}


void
on_kontrahentButtonOk_clicked (GtkButton * button, gpointer user_data)
{

  struct fAdres adres;
  struct fKontrahent kontrahent;

  //kontrahentWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));

  adres.ulica =
    Egtk_entry_get_text (kontrahentWindow, "kontrahentEntryUlica");
  adres.miejscowosc =
    Egtk_entry_get_text (kontrahentWindow, "kontrahentEntryMiejscowosc");
  adres.kod =
    g_strconcat (Egtk_entry_get_text
		 (kontrahentWindow, "kontrahentEntryKod1"),
		 Egtk_entry_get_text (kontrahentWindow,
				      "kontrahentEntryKod2"), NULL);

  kontrahent.adres = &adres;
  kontrahent.nazwa =
    Egtk_entry_get_text (kontrahentWindow, "kontrahentEntryNazwa");
  kontrahent.nip =
    g_strconcat (Egtk_entry_get_text
		 (kontrahentWindow, "kontrahentEntryNip1"),
		 Egtk_entry_get_text (kontrahentWindow,
				      "kontrahentEntryNip2"),
		 Egtk_entry_get_text (kontrahentWindow,
				      "kontrahentEntryNip3"),
		 Egtk_entry_get_text (kontrahentWindow,
				      "kontrahentEntryNip4"), NULL);

  kontrahent.regon =
    Egtk_entry_get_text (kontrahentWindow, "kontrahentEntryRegon");
  kontrahent.telefon = "";
  kontrahent.email = "";
  kontrahent.konto = "";
  kontrahent.podpis =
    Egtk_entry_get_text (kontrahentWindow, "kontrahentEntryPodpis");

  if (validKontrahent (&kontrahent))
    if (sqlAddKontrahent (&kontrahent))
      gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));


  free (adres.kod);


}


void
on_kontrahentButtonAnuluj_clicked (GtkButton * button, gpointer user_data)
{

  //GtkWidget *kontrahentWindow;

  //kontrahentWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("get_top_level\n");

  gtk_widget_destroy (kontrahentWindow);
  //g_print("destroy\n");


}

void
on_szukajKontrahentButtonOk_clicked (GtkButton * button, gpointer user_data)
{

  GtkWidget *szukajKontrahentWindow;
  GtkEntry *entry;
  gchar *str;

  if (selRowSzukajKontrahent > -1)
    {

      szukajKontrahentWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
      //g_print("get_top_level\n");


      //g_print("%p\n",fakturaWindow);
      ///TODO: Moze jakos obiektowo to mozna pobrac ???

      //Przepisywanie wartosci do fakturaWindow.Entry.Nipx
      //z Clist1(selRow,1)
      entry =
	GTK_ENTRY (lookup_widget
		   (fakturaWindow, "fakturaEntryKontrahentNip1"));

      /*gtk_clist_get_text(GTK_CLIST(
         lookup_widget(
         szukajKontrahentWindow,"szukajKontrahentClist1")),
         selRowSzukajKontrahent,0,&str);
       */

      Egtk_clist_get_text (szukajKontrahentWindow, "szukajKontrahentClist1",
			   selRowSzukajKontrahent, 0, &str);

      gtk_entry_set_text (entry, str);

      entry =
	GTK_ENTRY (lookup_widget
		   (fakturaWindow, "fakturaEntryKontrahentNip2"));
      gtk_entry_set_text (entry, str + 3);

      entry =
	GTK_ENTRY (lookup_widget
		   (fakturaWindow, "fakturaEntryKontrahentNip3"));
      gtk_entry_set_text (entry, str + 6);

      entry =
	GTK_ENTRY (lookup_widget
		   (fakturaWindow, "fakturaEntryKontrahentNip4"));
      gtk_entry_set_text (entry, str + 8);


      gtk_widget_destroy (szukajKontrahentWindow);

    }

}

void
on_szukajKontrahentEntrySzukaj_changed (GtkEditable * editable,
					gpointer user_data)
{

  gchar *strSql;
  gchar **strLike;
  GtkEntry *entry;
  G_CONST_RETURN gchar *str;
  gint i = 0;

  entry =
    GTK_ENTRY (lookup_widget
	       (GTK_WIDGET (gtk_widget_get_toplevel (GTK_WIDGET (editable))),
		"szukajKontrahentEntrySzukaj"));


  str = gtk_entry_get_text (entry);

  //g_printf("%s\n",str);
  strLike = g_strsplit (str, " ", 10);

  strSql = "SELECT nip,miejscowosc,nazwa FROM kontrahent WHERE 1=1 ";	//AND nip LIKE '%672%';";// WHERE 1=1 "; 



  while (strLike[i] != NULL)
    {
      strSql = g_strconcat (strSql,
			    " AND nip LIKE '%", strLike[i], "%' ", NULL);
      i++;
    }

  strSql = g_strconcat (strSql, ";", NULL);


  //g_printf("str=%s\n",strSql);

  /*from sql.c */
  sqlFillCList (GTK_CLIST
		(lookup_widget
		 (GTK_WIDGET
		  (gtk_widget_get_toplevel (GTK_WIDGET (editable))),
		  "szukajKontrahentClist1")), strSql);

  g_strfreev (strLike);
}


void
on_szukajKontrahentButtonDodaj_clicked (GtkButton * button,
					gpointer user_data)
{

  //GtkWidget *kontrahentWindow;
  GtkWidget *fakturaWindow;

  fakturaWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("create\n");
  kontrahentWindow = create_kontrahentWindow ();
  //g_print("create\n");
  gtk_widget_show (kontrahentWindow);
  //g_print("show\n");
  gtk_window_set_modal (GTK_WINDOW (kontrahentWindow), TRUE);
  //g_print("set_modal\n");
  gtk_window_set_transient_for (GTK_WINDOW (kontrahentWindow),
				GTK_WINDOW (fakturaWindow));
  //g_print("set_transient_for\n");

}


void
  on_szukajKontrahentButtonAnuluj_clicked
  (GtkButton * button, gpointer user_data)
{

  GtkWidget *szukajKontrahentWindow;

  szukajKontrahentWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("get_top_level\n");

  gtk_widget_destroy (szukajKontrahentWindow);
  //g_print("destroy\n");

}


void
on_szukajKontrahentButtonUsun_clicked (GtkButton * button, gpointer user_data)
{

  if (selRowSzukajKontrahent > -1)
    {
      sqlDelKontrahent (GTK_CLIST
			(lookup_widget
			 (GTK_WIDGET
			  (gtk_widget_get_toplevel (GTK_WIDGET (button))),
			  "szukajKontrahentClist1")), selRowSzukajKontrahent);

      sqlFillCList (GTK_CLIST
		    (lookup_widget
		     (GTK_WIDGET
		      (gtk_widget_get_toplevel (GTK_WIDGET (button))),
		      "szukajKontrahentClist1")),
		    "SELECT nip,miejscowosc,nazwa FROM kontrahent;");
    }

}


void
on_towarEntryKod_changed (GtkEditable * editable, gpointer user_data)
{

}


void
on_towarButtonOk_clicked (GtkButton * button, gpointer user_data)
{

  struct fTowar towar;

  towar.kod = Egtk_entry_get_text (towarWindow, "towarEntryKod");
  towar.nazwa = Egtk_entry_get_text (towarWindow, "towarEntryNazwa");
  towar.pkwiu = Egtk_entry_get_text (towarWindow, "towarEntryPkwiu");
  towar.cena_jd =
    atof (Egtk_entry_get_text (towarWindow, "towarEntryCenaJd"));
  towar.stawka_vat =
    Egtk_entry_get_text (towarWindow, "towarComboEntryStawka");

  sqlAddTowar (&towar);

  gtk_widget_destroy (gtk_widget_get_toplevel (GTK_WIDGET (button)));

}


void
on_towarButtonAnuluj_clicked (GtkButton * button, gpointer user_data)
{

  //GtkWidget *towarWindow;

  //towarWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  //g_print("get_top_level\n");

  gtk_widget_destroy (towarWindow);
  //g_print("destroy\n");

}


void
on_towarRadiobuttonTowar_clicked (GtkButton * button, gpointer user_data)
{

}


void
on_towarRadiobuttonUsluga_clicked (GtkButton * button, gpointer user_data)
{

}


void
on_szukajTowarEntrySzukaj_changed (GtkEditable * editable, gpointer user_data)
{

}


void
on_szukajTowarButtonOk_clicked (GtkButton * button, gpointer user_data)
{

  GtkWidget *szukajTowarWindow;
  GtkEntry *entry;
  gchar *str;

  if (selRowSzukajTowar > -1)
    {

      szukajTowarWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
      //g_print("get_top_level\n");


      //g_print("%p\n",fakturaWindow);

      //Przepisywanie wartosci do fakturaWindow.Entry.Nipx
      //z Clist1(selRow,1)
      entry = GTK_ENTRY (lookup_widget (fakturaWindow, "fakturaEntryKod"));

      gtk_clist_get_text (GTK_CLIST
			  (lookup_widget
			   (szukajTowarWindow, "szukajTowarClist1")),
			  selRowSzukajTowar, 0, &str);

      gtk_entry_set_text (entry, str);

      gtk_widget_destroy (szukajTowarWindow);

    }
}


void
on_szukajTowarButtonDodaj_clicked (GtkButton * button, gpointer user_data)
{

  //GtkWidget *towarWindow;
  GtkWidget *fakturaWindow;

  fakturaWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  g_print ("create\n");
  towarWindow = create_towarWindow ();
  g_print ("create\n");
  gtk_widget_show (towarWindow);
  g_print ("show\n");
  gtk_window_set_modal (GTK_WINDOW (towarWindow), TRUE);
  g_print ("set_modal\n");
  gtk_window_set_transient_for (GTK_WINDOW (towarWindow),
				GTK_WINDOW (fakturaWindow));
  g_print ("set_transient_for\n");

}


void
on_szukajTowarButtonAnuluj_clicked (GtkButton * button, gpointer user_data)
{

  GtkWidget *szukajTowarWindow;

  szukajTowarWindow = gtk_widget_get_toplevel (GTK_WIDGET (button));
  g_print ("get_top_level\n");

  gtk_widget_destroy (szukajTowarWindow);
  g_print ("destroy\n");

}


void
on_szukajTowarButtonUsun_clicked (GtkButton * button, gpointer user_data)
{

  gchar *tmp;
  gchar *strSql;

  if (selRowSzukajTowar != -1)
    {
      Egtk_clist_get_text (szukajTowarWindow,
			   "szukajTowarClist1", selRowSzukajTowar, 0, &tmp);

      g_print ("Usun=%s\n", tmp);

      if (sqlDelTowar (tmp) != TRUE)
	errorMySql (szukajTowarWindow);

      strSql = "SELECT kod,pkwiu,nazwa FROM towar;";

      /*from sql.c */
      sqlFillCList (GTK_CLIST (lookup_widget (szukajTowarWindow,
					      "szukajTowarClist1")), strSql);

      selRowSzukajTowar = -1;
    }



}


void
on_szukajFakturaEntrySzukaj_changed (GtkEditable * editable,
				     gpointer user_data)
{

}


void
on_szukajFakturaButtonOk_clicked (GtkButton * button, gpointer user_data)
{

}


void
on_szukajFakturaButtonDodaj_clicked (GtkButton * button, gpointer user_data)
{

}


void
on_szukajFakturaButtonAnuluj_clicked (GtkButton * button, gpointer user_data)
{

}


void
on_szukajFakturaButtonUsun_clicked (GtkButton * button, gpointer user_data)
{

}


gboolean
on_fakturaWindow_delete_event (GtkWidget * widget,
			       GdkEvent * event, gpointer user_data)
{

  g_print ("delete_event\n");

  sqlClose ();
  gtk_main_quit ();
  return FALSE;
}


void
on_fakturaWindow_realize (GtkWidget * widget, gpointer user_data)
{
// wstawia elementy do sposobu zaplaty
  GtkCombo *combo;
  GList *list = NULL;
  GtkList *lista;

  ///TODO Przerobic aby wstawialo sie z bazy
  list = g_list_append (list, "Gotówka");
  list = g_list_append (list, "Karta");
  list = g_list_append (list, "Przelew 7 dni");
  list = g_list_append (list, "Przelew 14 dni");
  list = g_list_append (list, "Termin 7 dni");
  list = g_list_append (list, "Termin 14 dni");

  //fakturaComboSposobZaplay
  //combo = GTK_COMBO(lookup_widget(fakturaWindow,"fakturaComboSposobZaplay"));   
  Egtk_combo_set_popdown_strings (fakturaWindow, "fakturaComboSposobZaplay",
				  list);
  //gtk_combo_set_popdown_strings(GTK_COMBO(lookup_widget(fakturaWindow,
  //      "fakturaComboSposobZaplay")),list);

  //gtk_list_append_items(lista,list);

  //Egtk_list_append_items(combo,"fakturaComboListSposobZaplaty",list);

  //g_print("gtk_list_append_items\n");


}

/** Po pokazaniu okna
 *
 * Laczy z baza danych jezeli nie to pyta czy kontynuowac
 * \todo Lepszy sposob zamkniecia aplikacji
 */

void
on_fakturaWindow_show (GtkWidget * widget, gpointer user_data)
{
  gboolean open;
  open = sqlInit ();
  g_print ("open=%d\n", open);
  if (open != TRUE)
    {
      if (errorPolaczenie () != TRUE)
	{
	  on_fakturaWindow_delete_event (NULL, NULL, NULL);
	  gtk_widget_destroy (fakturaWindow);
	  gtk_main_quit ();
	  exit (0);
	}
    }
  //g_print("error=%d\tTRUE==%d\n",errorPolaczenie(),TRUE);
  //gtk_main_quit();

  //g_print("fakturaWindow.Show\n");

}


void
on_kontrahentWindow_show (GtkWidget * widget, gpointer user_data)
{

}


void
on_kontrahentWindow_realize (GtkWidget * widget, gpointer user_data)
{

}


void
on_szukajKontrahentWindow_show (GtkWidget * widget, gpointer user_data)
{

}


void
on_szukajKontrahentWindow_realize (GtkWidget * widget, gpointer user_data)
{
  gchar *strSql;

  strSql = "SELECT nip,miejscowosc,nazwa FROM kontrahent;";

  /*from sql.c */
  sqlFillCList (GTK_CLIST (lookup_widget (widget,
					  "szukajKontrahentClist1")), strSql);


}


void
on_towarWindow_show (GtkWidget * widget, gpointer user_data)
{

}


void
on_towarWindow_realize (GtkWidget * widget, gpointer user_data)
{

  GtkCombo *combo;
  GList *list = NULL;
  GtkList *lista;

  ///TODO Przerobic aby wstawialo sie z bazy
  list = g_list_append (list, "22%");
  list = g_list_append (list, "7%");
  list = g_list_append (list, "4%");
  list = g_list_append (list, "3%");
  list = g_list_append (list, "zw.");

  //fakturaComboSposobZaplay
  combo = GTK_COMBO (lookup_widget (towarWindow, "towarComboStawka"));
  g_print ("TU\n");
  Egtk_combo_set_popdown_strings (towarWindow, "towarComboStawka", list);

}


void
on_szukajTowarWindow_realize (GtkWidget * widget, gpointer user_data)
{
  gchar *strSql;

  strSql = "SELECT kod,pkwiu,nazwa FROM towar;";

  /*from sql.c */
  sqlFillCList (GTK_CLIST (lookup_widget (widget,
					  "szukajTowarClist1")), strSql);

  selRowSzukajTowar = -1;
}


void
on_szukajTowarWindow_show (GtkWidget * widget, gpointer user_data)
{

}


void
on_szukajFakturaWindow_show (GtkWidget * widget, gpointer user_data)
{

}


void
on_szukajFakturaWindow_realize (GtkWidget * widget, gpointer user_data)
{

}


gboolean
on_szukajKontrahentWindow_delete_event (GtkWidget * widget,
					GdkEvent * event, gpointer user_data)
{

  selRowSzukajKontrahent = -1;

  return FALSE;
}


gboolean
on_towarWindow_delete_event (GtkWidget * widget,
			     GdkEvent * event, gpointer user_data)
{

  return FALSE;
}


gboolean
on_szukajTowarWindow_delete_event (GtkWidget * widget,
				   GdkEvent * event, gpointer user_data)
{

  return FALSE;
}


gboolean
on_szukajFakturaWindow_delete_event (GtkWidget * widget,
				     GdkEvent * event, gpointer user_data)
{

  return FALSE;
}

gboolean
on_kontrahentWindow_delete_event (GtkWidget * widget,
				  GdkEvent * event, gpointer user_data)
{

  return FALSE;
}

void
on_fakturaEntryKod_changed (GtkEditable * editable, gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  if (strlen (str) >= 6)
    sqlFillSzczegol (GTK_WIDGET (editable));

}


void
on_fakturaEntryKontrahentKod1_changed (GtkEditable * editable,
				       gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 2)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "fakturaEntryKontrahentKod2"));

}


void
on_fakturaEntryKontrahentKod2_changed (GtkEditable * editable,
				       gpointer user_data)
{
  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 3)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "fakturaEntryKontrahentMiejscowosc"));

}


void
on_kontrahentEntryKod1_changed (GtkEditable * editable, gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 2)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "kontrahentEntryKod2"));

}


void
on_kontrahentEntryKod2_changed (GtkEditable * editable, gpointer user_data)
{

  G_CONST_RETURN gchar *str;

  str = gtk_entry_get_text (GTK_ENTRY (editable));

  //g_print("strlen=%d\n",strlen(str));
  if (strlen (str) >= 3)
    gtk_widget_grab_focus (lookup_widget
			   (gtk_widget_get_toplevel (GTK_WIDGET (editable)),
			    "kontrahentEntryMiejscowosc"));

}


void
on_szukajKontrahentClist1_select_row (GtkCList * clist,
				      gint row,
				      gint column,
				      GdkEvent * event, gpointer user_data)
{

  selRowSzukajKontrahent = row;
  //g_print("row=%d\n",row);
}


void
on_szukajKontrahentClist1_unselect_row (GtkCList * clist,
					gint row,
					gint column,
					GdkEvent * event, gpointer user_data)
{

  selRowSzukajKontrahent = -1;
  //g_print("row=%d\n",selRow);
}


void
  on_szukajKontrahentButtonOdswiez_clicked
  (GtkButton * button, gpointer user_data)
{

  sqlFillCList (GTK_CLIST
		(lookup_widget
		 (GTK_WIDGET (gtk_widget_get_toplevel (GTK_WIDGET (button))),
		  "szukajKontrahentClist1")),
		"SELECT nip,miejscowosc,nazwa FROM kontrahent;");

}


void
on_szukajTowarButtonOdswiez_clicked (GtkButton * button, gpointer user_data)
{

  gchar *strSql;

  strSql = "SELECT kod,pkwiu,nazwa FROM towar;";

  /*from sql.c */
  sqlFillCList (GTK_CLIST (lookup_widget (GTK_WIDGET (button),
					  "szukajTowarClist1")), strSql);

}


void
on_szukajFakturaButtonOdswiez_clicked (GtkButton * button, gpointer user_data)
{

}


void
on_fakturaClist_select_row (GtkCList * clist,
			    gint row,
			    gint column, GdkEvent * event, gpointer user_data)
{

  selRowFaktura = row;
  //g_print("row=%d\n",row);

}


void
on_fakturaClist_unselect_row (GtkCList * clist,
			      gint row,
			      gint column,
			      GdkEvent * event, gpointer user_data)
{

  selRowFaktura = -1;

}


void
on_szukajTowarClist1_select_row (GtkCList * clist,
				 gint row,
				 gint column,
				 GdkEvent * event, gpointer user_data)
{

  selRowSzukajTowar = row;

}


void
on_szukajTowarClist1_unselect_row (GtkCList * clist,
				   gint row,
				   gint column,
				   GdkEvent * event, gpointer user_data)
{

  selRowSzukajTowar = -1;

}


void
on_szukajFakturaClist2_select_row (GtkCList * clist,
				   gint row,
				   gint column,
				   GdkEvent * event, gpointer user_data)
{

}


void
on_szukajFakturaClist2_unselect_row (GtkCList * clist,
				     gint row,
				     gint column,
				     GdkEvent * event, gpointer user_data)
{

}
