/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef HAVE_CALLBACKS_H_798432789342879

#define HAVE_CALLBACKS_H_798432789342879

#include <gnome.h>
#include <easy.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "interface.h"
#include "support.h"
#include "sql.h"
#include "types.h"
#include "validate.h"

extern GtkWidget *fakturaWindow;
extern GtkWidget *szukajTowarWindow;
extern GtkWidget *towarWindow;
extern GtkWidget *kontrahentWindow;

void on_new1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_save1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_quit1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_cut1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_copy1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_paste1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_clear1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_properties1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_preferences1_activate (GtkMenuItem * menuitem, gpointer user_data);

void on_about1_activate (GtkMenuItem * menuitem, gpointer user_data);

void
on_fakturaToolBoxButtonNowy_clicked (GtkButton * button, gpointer user_data);

void
on_fakturaToolBoxButtonZapisz_clicked (GtkButton * button,
				       gpointer user_data);

void
  on_fakturaToolBoxButtonWydrukuj_clicked
  (GtkButton * button, gpointer user_data);

void
on_fakturaToolBoxButtonZakoncz_clicked (GtkButton * button,
					gpointer user_data);

void
on_fakturaEntryKontrahentNip1_changed (GtkEditable * editable,
				       gpointer user_data);

void
on_fakturaEntryKontrahentNip2_changed (GtkEditable * editable,
				       gpointer user_data);

void
on_fakturaEntryKontrahentNip3_changed (GtkEditable * editable,
				       gpointer user_data);

void
on_fakturaEntryKontrahentNip4_changed (GtkEditable * editable,
				       gpointer user_data);

void
on_fakturaButtonKontrahentNowy_clicked (GtkButton * button,
					gpointer user_data);

void
  on_fakturaButtonKontrahentZnajdz_clicked
  (GtkButton * button, gpointer user_data);

void
on_fakturaButtonSzczegolyDodaj_clicked (GtkButton * button,
					gpointer user_data);

void
on_fakturaButtonSzczegolyUsun_clicked (GtkButton * button,
				       gpointer user_data);

void
on_fakturaButtonSzczegolyOk_clicked (GtkButton * button, gpointer user_data);

void
  on_fakturaButtonSzczegolyZnajdz_clicked
  (GtkButton * button, gpointer user_data);

void
on_fakturaButtonSzczegolyNowy_clicked (GtkButton * button,
				       gpointer user_data);

void
on_kontrahentEntryNip1_changed (GtkEditable * editable, gpointer user_data);

void
on_kontrahentEntryNip2_changed (GtkEditable * editable, gpointer user_data);

void
on_kontrahentEntryNip3_changed (GtkEditable * editable, gpointer user_data);

void
on_kontrahentEntryNip4_changed (GtkEditable * editable, gpointer user_data);

void on_kontrahentButtonOk_clicked (GtkButton * button, gpointer user_data);

void
on_kontrahentButtonAnuluj_clicked (GtkButton * button, gpointer user_data);

void
on_szukajKontrahentEntrySzukaj_changed (GtkEditable * editable,
					gpointer user_data);

void
on_szukajKontrahentButtonOk_clicked (GtkButton * button, gpointer user_data);

void
on_szukajKontrahentButtonDodaj_clicked (GtkButton * button,
					gpointer user_data);

void
  on_szukajKontrahentButtonAnuluj_clicked
  (GtkButton * button, gpointer user_data);

void
on_szukajKontrahentButtonUsun_clicked (GtkButton * button,
				       gpointer user_data);

void on_towarEntryKod_changed (GtkEditable * editable, gpointer user_data);

void on_towarButtonOk_clicked (GtkButton * button, gpointer user_data);

void on_towarButtonAnuluj_clicked (GtkButton * button, gpointer user_data);

void
on_towarRadiobuttonTowar_clicked (GtkButton * button, gpointer user_data);

void
on_towarRadiobuttonUsluga_clicked (GtkButton * button, gpointer user_data);

void
on_szukajTowarEntrySzukaj_changed (GtkEditable * editable,
				   gpointer user_data);

void on_szukajTowarButtonOk_clicked (GtkButton * button, gpointer user_data);

void
on_szukajTowarButtonDodaj_clicked (GtkButton * button, gpointer user_data);

void
on_szukajTowarButtonAnuluj_clicked (GtkButton * button, gpointer user_data);

void
on_szukajTowarButtonUsun_clicked (GtkButton * button, gpointer user_data);

void
on_szukajFakturaEntrySzukaj_changed (GtkEditable * editable,
				     gpointer user_data);

void
on_szukajFakturaButtonOk_clicked (GtkButton * button, gpointer user_data);

void
on_szukajFakturaButtonDodaj_clicked (GtkButton * button, gpointer user_data);

void
on_szukajFakturaButtonAnuluj_clicked (GtkButton * button, gpointer user_data);

void
on_szukajFakturaButtonUsun_clicked (GtkButton * button, gpointer user_data);

gboolean
on_fakturaWindow_delete_event (GtkWidget * widget,
			       GdkEvent * event, gpointer user_data);

void on_fakturaWindow_realize (GtkWidget * widget, gpointer user_data);

void on_fakturaWindow_show (GtkWidget * widget, gpointer user_data);

void on_kontrahentWindow_show (GtkWidget * widget, gpointer user_data);

void on_kontrahentWindow_realize (GtkWidget * widget, gpointer user_data);

void on_szukajKontrahentWindow_show (GtkWidget * widget, gpointer user_data);

void
on_szukajKontrahentWindow_realize (GtkWidget * widget, gpointer user_data);

void on_towarWindow_show (GtkWidget * widget, gpointer user_data);

void on_towarWindow_realize (GtkWidget * widget, gpointer user_data);

void on_szukajTowarWindow_realize (GtkWidget * widget, gpointer user_data);

void on_szukajTowarWindow_show (GtkWidget * widget, gpointer user_data);

void on_szukajFakturaWindow_show (GtkWidget * widget, gpointer user_data);

void on_szukajFakturaWindow_realize (GtkWidget * widget, gpointer user_data);

gboolean
on_kontrahentWindow_delete_event (GtkWidget * widget,
				  GdkEvent * event, gpointer user_data);

gboolean
on_szukajKontrahentWindow_delete_event (GtkWidget * widget,
					GdkEvent * event, gpointer user_data);

gboolean
on_towarWindow_delete_event (GtkWidget * widget,
			     GdkEvent * event, gpointer user_data);

gboolean
on_szukajTowarWindow_delete_event (GtkWidget * widget,
				   GdkEvent * event, gpointer user_data);

gboolean
on_szukajFakturaWindow_delete_event (GtkWidget * widget,
				     GdkEvent * event, gpointer user_data);

void on_fakturaEntry9_changed (GtkEditable * editable, gpointer user_data);

void on_fakturaEntryKod_changed (GtkEditable * editable, gpointer user_data);

void
on_fakturaEntryKontrahentKod1_changed (GtkEditable * editable,
				       gpointer user_data);

void
on_fakturaEntryKontrahentKod2_changed (GtkEditable * editable,
				       gpointer user_data);

void
on_kontrahentEntryKod1_changed (GtkEditable * editable, gpointer user_data);

void
on_kontrahentEntryKod2_changed (GtkEditable * editable, gpointer user_data);

void
on_szukajKontrahentClist1_select_row (GtkCList * clist,
				      gint row,
				      gint column,
				      GdkEvent * event, gpointer user_data);

void
on_szukajKontrahentClist1_unselect_row (GtkCList * clist,
					gint row,
					gint column,
					GdkEvent * event, gpointer user_data);

void
  on_szukajKontrahentButtonOdswiez_clicked
  (GtkButton * button, gpointer user_data);

void
on_szukajTowarButtonOdswiez_clicked (GtkButton * button, gpointer user_data);

void
on_szukajFakturaButtonOdswiez_clicked (GtkButton * button,
				       gpointer user_data);

void
on_fakturaClist_select_row (GtkCList * clist,
			    gint row,
			    gint column,
			    GdkEvent * event, gpointer user_data);

void
on_fakturaClist_unselect_row (GtkCList * clist,
			      gint row,
			      gint column,
			      GdkEvent * event, gpointer user_data);

void
on_szukajTowarClist1_select_row (GtkCList * clist,
				 gint row,
				 gint column,
				 GdkEvent * event, gpointer user_data);

void
on_szukajTowarClist1_unselect_row (GtkCList * clist,
				   gint row,
				   gint column,
				   GdkEvent * event, gpointer user_data);

void
on_szukajFakturaClist2_select_row (GtkCList * clist,
				   gint row,
				   gint column,
				   GdkEvent * event, gpointer user_data);

void
on_szukajFakturaClist2_unselect_row (GtkCList * clist,
				     gint row,
				     gint column,
				     GdkEvent * event, gpointer user_data);


#endif // HAVE_CALLBACKS_H_798432789342879
