/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/** \file
 * \brief Zawiera makra operujace na interfejsie
 *
 * Nazwy makr maja nastepujaca strukture
 * E[nazwa_funkcji_gtk]
 * parametrami makra jest
 * wskaznik na okno
 * nazwa obiektu, dla ktorego wywolywana jest funkcja
 * kolejne argumenty funkcji
 */

#ifndef HAVE_EASY_H_798432789342879

#define HAVE_EASY_H_798432789342879

#include <config.h>
#include <stdlib.h>
#include <stdio.h>
#include <gnome.h>
#include <support.h>
#include <glib.h>

/// Zwraca wskaznik na tekst
/** \example ../example/easy_001.c
 * Zwraca wskaznik typu G_CONST_RETURN gchar* na tekst 
 * przechowywany przez widget fakturaEntryStawka z okna fakturaWindow
 */
inline G_CONST_RETURN gchar *Egtk_entry_get_text (GtkWidget * window,
						  gchar * entry);

//#define Egtk_entry_get_text(window,entry) \
//      gtk_entry_get_text(GTK_ENTRY(lookup_widget(window,entry)))

/// Ustawia tekst w entry
#define Egtk_entry_set_text(window,entry,text) \
	gtk_entry_set_text(GTK_ENTRY(lookup_widget(window,entry)),text)


/// Ustawia focus
#define Egtk_widget_grab_focus(window,widget) \
	gtk_widget_grab_focus( lookup_widget( \
				gtk_widget_get_toplevel(window, \
				"fakturaEntryKontrahentNip2" )))

/// Wstawia do listy
#define Egtk_clist_insert(window,list,row,text) \
	gtk_clist_insert(GTK_CLIST( \
		lookup_widget(window,list)), \
		row,text)


/// Usuwa z listy
#define Egtk_clist_remove(window,list,row) \
	gtk_clist_remove(GTK_CLIST( \
		   lookup_widget(window,list)),row)


/// Zwraca text z clisyu
#define Egtk_clist_get_text(window,clist,row,col,text) \
	gtk_clist_get_text(GTK_CLIST( \
		lookup_widget(window,clist)), row,col,text)

/// Dodanie do Comba Glist'y
#define Egtk_combo_set_popdown_strings(window,combo,list) \
	gtk_combo_set_popdown_strings(GTK_COMBO( \
		lookup_widget(window,combo)),list)

///Dodanie do Comba jednego String'a
/// \attention W wersji 2.2.1 GTK+ nie mozna pobrac listy
/// \todo GTK+ metode dla GtkCombo pobierajaca wskaznik na GList
#define Egtk_combo_set_popdown_string(window,combo,string) \
	gtk_combo_set_popdown_strings(GTK_COMBO( \
		lookup_widget(window,combo)),g_list_append( \
		(GTK_LIST(lookup_widget(window,combo)))->list,string))

#endif // ifndef HAVE_EASY_H_798432789342879
