/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/** \file
 * \brief Zawiera funkcje operujace na interfejsie graficznym
 *
 * Funkcje operuja na obiektach formularzy i zwracaja
 * wartosci obiektow.
 * \author Michal Lachowicz <MLachowicz@elka.pw.edu.pl>
 */


#include <finterface.h>

///Zwraca wartosc NIPu kontrahenta z pol Nip1-4

/** W przypadku bledu wyrzuca komunikat przez g_print()
 * \todo obsluge bledow g_string'a
 */

gchar *
fakturaWindowKontrahentNip ()
{
  GString *result;
  gchar *temp;

  result =
    g_string_new (Egtk_entry_get_text
		  (fakturaWindow, "fakturaEntryKontrahentNip1"));

  result = g_string_append (result,
			    Egtk_entry_get_text (fakturaWindow,
						 "fakturaEntryKontrahentNip2"));

  result = g_string_append (result,
			    Egtk_entry_get_text (fakturaWindow,
						 "fakturaEntryKontrahentNip3"));

  result = g_string_append (result,
			    Egtk_entry_get_text (fakturaWindow,
						 "fakturaEntryKontrahentNip4"));

  temp = result->str;

  g_string_free (result, FALSE);

  return temp;
}

///Zwraca wartosc KOD'u pocztowego kontrahenta z pol Kod1-2

/** \todo Niedokonczone
 */

gchar *
fakturaWindowKontrahentKod ()
{
  GString *result;

  result =
    g_string_new (Egtk_entry_get_text
		  (fakturaWindow, "fakturaEntryKontrahentKod1"));

  result = g_string_append (result,
			    Egtk_entry_get_text (fakturaWindow,
						 "fakturaEntryKontrahentKod2"));


}
