/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/** \file
 * \brief Zawiera funkcje wydruku do xml
 * 
 * Funkcje zwracaja wartosc TRUE jezeli wszystko sie powiodlo
 * Funkcje zawieraja przedrostek print
 * \author MLachowicz <MLachowicz@elka.pw.edu.pl>
 */

#include <print.h>

///Drukuje fakture do pliku xmlowego

/** W przypadku bledu wyrzuca komunikat przez g_print
 * \todo DTD dla faktury
 */

gboolean
printFaktura (gchar * docname, struct fFaktura * faktura)
{

  xmlDocPtr doc;
  xmlNodePtr root, cur, xmlfaktura, xmlzawartosc, xmlszczegoly, xmlrazem;
  gchar temp[255];
  int j = 0;
  //struct xmlOutputBuffer out;

  //Stworzenie szablonu
  //doc = xmlParseFile("faktury.xml");
  doc = xmlNewDoc ("1.0");

  if (doc == NULL)
    {
      g_fprintf (stderr, "Document not parsed successfully. \n");
      return (FALSE);
    }

  //cur = xmlDocGetRootElement(doc);
  //dodanie elementu glownego

  root = xmlNewNode (NULL, "FAKTURY");
  xmlDocSetRootElement (doc, root);

  //przypisanie root'a
  cur = root;
  //root = cur;

  if (cur == NULL)
    {
      g_fprintf (stderr, "empty document\n");
      xmlFreeDoc (doc);
      return (FALSE);
    }

  /// \warning wszystkie Tagi pisane sa wielkimi literami
  /*if (xmlStrcmp(cur->name, (const xmlChar *) "FAKTURY")) {
     g_fprintf(stderr,"document of the wrong type, root!=FAKTURY");
     xmlFreeDoc(doc);
     return (FALSE);
     } */

  //wlasciwe dodanie TAGow

  //FAKTURA
  cur = xmlNewTextChild (cur, NULL, "FAKTURA", NULL);
  //zachowujemy na pozniej
  xmlfaktura = cur;

  //FAKTURA@ID1
  g_sprintf (&temp, "%d", faktura->id1);
  xmlNewProp (cur, (const xmlChar *) "ID1", temp);
  //g_printf("numer\n");
  //FAKTURA@ID2
  g_sprintf (&temp, "%d", faktura->id2);
  xmlNewProp (cur, (const xmlChar *) "ID2", temp);
  //FAKTURA@NUMER
  g_printf ("numer=%s\n", faktura->numer);
  xmlNewProp (cur, (const xmlChar *) "NUMER", faktura->numer);

  //FAKTURA@miejscowosc_wystawienia
  g_print ("miejscowosc wystawienia %s\n", faktura->miejscowosc_wystawienia);

  xmlNewProp (cur, (const xmlChar *) "MIEJSCOWOSC_WYSTAWIENIA",
	      faktura->miejscowosc_wystawienia);

  //FAKTURA@data_wystawienia
  g_print ("data_wystawienia %s\n", faktura->data_wystawienia);

  xmlNewProp (cur, (const xmlChar *) "DATA_WYSTAWIENIA",
	      faktura->data_wystawienia);
  //FAKTURA@sposob_zaplaty
  xmlNewProp (cur, (const xmlChar *) "SPOSOB_ZAPLATY",
	      faktura->sposob_zaplaty);
  //FAKTURA@data_sprzedazy
  xmlNewProp (cur, (const xmlChar *) "DATA_SPRZEDARZY",
	      faktura->data_sprzedazy);
  //FAKTURA@otrzymujacy
  xmlNewProp (cur, (const xmlChar *) "OTRZYMUJACY", faktura->otrzymujacy);
  //FAKTURA@wystawiajacy
  xmlNewProp (cur, (const xmlChar *) "WYSTAWIAJACY", faktura->wystawiajacy);


  //FAKTURA/SPRZEDAWCA
  cur = xmlNewTextChild (cur, NULL, "SPRZEDAWCA", NULL);
  //FAKTURA/SPRZEDAWCA@ID1
  xmlNewProp (cur, (const xmlChar *) "ID1", "123");
  //FAKTURA/SPRZEDAWCA@ID2
  xmlNewProp (cur, (const xmlChar *) "ID2", "332");
  //FAKTURA/SPRZEDAWCA@NAZWA
  xmlNewProp (cur, (const xmlChar *) "NAZWA",
	      (const xmlChar *) "Michal Lachowicz");
  //FAKTURA/SPRZEDAWCA@NIP
  xmlNewProp (cur, (const xmlChar *) "NIP",
	      (const xmlChar *) "672-170-69-40");
  //FAKTURA/SPRZEDAWCA@REGON
  xmlNewProp (cur, (const xmlChar *) "REGON", (const xmlChar *) "3330000000");
  //FAKTURA/SPRZEDAWCA@TELEFON
  xmlNewProp (cur, (const xmlChar *) "TELEFON",
	      (const xmlChar *) "507-084-099");
  //FAKTURA/SPRZEDAWCA@EMAIL
  xmlNewProp (cur, (const xmlChar *) "EMAIL",
	      (const xmlChar *) "MLachowicz@lmsoft.org");
  //FAKTURA/SPRZEDAWCA@KONTO
  xmlNewProp (cur, (const xmlChar *) "KONTO",
	      (const xmlChar *) "198723815237651287369182");


  //FAKTURA/SPRZEDAWCA/ADRES
  cur = xmlNewTextChild (cur, NULL, "ADRES", NULL);
  //FAKTURA/SPRZEDAWCA/ADRES@ULICA
  xmlNewProp (cur, (const xmlChar *) "ULICA",
	      (const xmlChar *) "ul. Felixa Stamma 1/37");
  //FAKTURA/SPRZEDAWCA/ADRES@MIEJSCOWOSC
  xmlNewProp (cur, (const xmlChar *) "MIEJSCOWOSC",
	      (const xmlChar *) "Bialogard");
  //FAKTURA/SPRZEDAWCA/ADRES@KOD
  xmlNewProp (cur, (const xmlChar *) "KOD", (const xmlChar *) "78-200");


  //FAKTURA/NABYWCA
  cur = xmlNewTextChild (xmlfaktura, NULL, "NABYWCA", NULL);

  //FAKTURA/NABYWCA@ID1
  g_sprintf (&temp, "%d", faktura->nabywca->id1);
  xmlNewProp (cur, (const xmlChar *) "ID1", temp);
  //FAKTURA/NABYWCA@ID2
  g_sprintf (&temp, "%d", faktura->nabywca->id2);
  xmlNewProp (cur, (const xmlChar *) "ID2", temp);
  //FAKTURA/NABYWCA@NAZWA
  xmlNewProp (cur, (const xmlChar *) "NAZWA", faktura->nabywca->nazwa);
  //FAKTURA/NABYWCA@NIP
  xmlNewProp (cur, (const xmlChar *) "NIP", faktura->nabywca->nip);
  //FAKTURA/NABYWCA@REGON
  xmlNewProp (cur, (const xmlChar *) "REGON", faktura->nabywca->regon);
  //FAKTURA/NABYWCA@TELEFON
  xmlNewProp (cur, (const xmlChar *) "TELEFON", faktura->nabywca->telefon);
  //FAKTURA/NABYWCA@EMAIL
  xmlNewProp (cur, (const xmlChar *) "EMAIL", faktura->nabywca->email);
  //FAKTURA/NABYWCA@KONTO
  xmlNewProp (cur, (const xmlChar *) "KONTO", faktura->nabywca->konto);


  //FAKTURA/NABYWCA/ADRES
  cur = xmlNewTextChild (cur, NULL, "ADRES", NULL);
  //FAKTURA/NABYWCA/ADRES@ULICA
  xmlNewProp (cur, (const xmlChar *) "ULICA",
	      (const xmlChar *) "ul. Felixa Stamma 1/37");
  //FAKTURA/NABYWCA/ADRES@MIEJSCOWOSC
  xmlNewProp (cur, (const xmlChar *) "MIEJSCOWOSC",
	      (const xmlChar *) "Bialogard");
  //FAKTURA/NABYWCA/ADRES@KOD
  xmlNewProp (cur, (const xmlChar *) "KOD", (const xmlChar *) "78-200");



  //FAKTURA/ZAWARTOSC
  cur = xmlNewTextChild (xmlfaktura, NULL, "ZAWARTOSC", NULL);
  xmlzawartosc = cur;

  //FAKTURA/ZAWARTOSC/SZCZEGOLY
  cur = xmlNewTextChild (cur, NULL, "SZCZEGOLY", NULL);
  xmlszczegoly = cur;

  g_print ("przed for\n");
  for (j = 0; faktura->szczegoly_ilosc != j; ++j)
    {
      struct fSzczegol *szczegol = g_ptr_array_index (faktura->szczegoly, j);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL
      cur = xmlNewTextChild (xmlszczegoly, NULL, "SZCZEGOL", NULL);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@LP
      g_sprintf (&temp, "%d", szczegol->lp);
      xmlNewProp (cur, (const xmlChar *) "LP", temp);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@NAZWA
      xmlNewProp (cur, (const xmlChar *) "NAZWA", szczegol->nazwa);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@PKWIU
      xmlNewProp (cur, (const xmlChar *) "PKWIU", szczegol->pkwiu);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@ILOSC
      g_sprintf (&temp, "%f", szczegol->ilosc);
      xmlNewProp (cur, (const xmlChar *) "ILOSC", temp);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@JD_MIARY
      xmlNewProp (cur, (const xmlChar *) "JD_MIARY", szczegol->jd_miary);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@CENA_JD
      g_sprintf (&temp, "%f", szczegol->cena_jd);
      xmlNewProp (cur, (const xmlChar *) "CENA_JD", temp);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@WARTOSC_NETTO
      g_sprintf (&temp, "%f", szczegol->wartosc_netto);
      xmlNewProp (cur, (const xmlChar *) "WARTOSC_NETTO", temp);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@STAWKA_VAT
      xmlNewProp (cur, (const xmlChar *) "STAWKA_VAT", szczegol->stawka_vat);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@KWOTA_PODATKU
      g_sprintf (&temp, "%f", szczegol->kwota_podatku);
      xmlNewProp (cur, (const xmlChar *) "KWOTA_PODATKU", temp);
      //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@WARTOSC_BRUTTO
      g_sprintf (&temp, "%f", szczegol->wartosc_brutto);
      xmlNewProp (cur, (const xmlChar *) "WARTOSC_BRUTTO", temp);
    }

  g_print ("przed razem\n");
  //FAKTURA/ZAWARTOSC/RAZEM
  cur = xmlNewTextChild (xmlzawartosc, NULL, "RAZEM", NULL);
  xmlrazem = cur;
  //FAKTURA/ZAWARTOSC/RAZEM@WARTOSC_NETTO
  g_sprintf (&temp, "%f", faktura->razem->wartosc_netto);
  xmlNewProp (cur, (const xmlChar *) "WARTOSC_NETTO", temp);
  //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@KWOTA_PODATKU
  g_sprintf (&temp, "%f", faktura->razem->kwota_podatku_vat);
  xmlNewProp (cur, (const xmlChar *) "KWOTA_PODATKU", temp);
  //FAKTURA/ZAWARTOSC/SZCZEGOLY/SZCZEGOL@WARTOSC_BRUTTO
  g_sprintf (&temp, "%f", faktura->razem->wartosc_brutto);
  xmlNewProp (cur, (const xmlChar *) "WARTOSC_BRUTTO", temp);

  for (j = 0; faktura->razem->stawka_ilosc != j; ++j)
    {
      struct fStawka *stawka = g_ptr_array_index (faktura->razem->stawka, j);
      //FAKTURA/ZAWARTOSC/RAZEM/STAWKA
      cur = xmlNewTextChild (xmlrazem, NULL, "STAWKA", NULL);
      //FAKTURA/ZAWARTOSC/RAZEM/STAWKA@STAWKA
      xmlNewProp (cur, (const xmlChar *) "STAWKA", stawka->stawka);
      //FAKTURA/ZAWARTOSC/RAZEM/STAWKA@ARTOSC_NETTO
      g_sprintf (&temp, "%f", stawka->wartosc_netto);
      xmlNewProp (cur, (const xmlChar *) "WARTOSC_NETTO", temp);
      //FAKTURA/ZAWARTOSC/RAZEM/STAWKA@KWOTA_PODATKU
      g_sprintf (&temp, "%f", stawka->kwota_podatku_vat);
      xmlNewProp (cur, (const xmlChar *) "KWOTA_PODATKU", temp);
      //FAKTURA/ZAWARTOSC/RAZEM/STAWKA@WARTOSC_BRUTTO
      g_sprintf (&temp, "%f", stawka->wartosc_brutto);
      xmlNewProp (cur, (const xmlChar *) "WARTOSC_BRUTTO", temp);
    }


  g_printf ("przed zapis\n");
  //stworzenie xmlOutputBuffer
  //out.

  //zapis do pliku
  xmlSaveFileEnc ("faktura01.xml", doc, "UTF-8");


}
